const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const pessoas_frame = sequelize.define(
    'pessoas_frame',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      atividade: {
        type: DataTypes.TEXT,
      },

      posicao_aproximada: {
        type: DataTypes.TEXT,
      },

      epi_visiveis: {
        type: DataTypes.TEXT,
      },

      foco_no_trabalho: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      operando_maquina: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  pessoas_frame.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.pessoas_frame.belongsTo(db.frames_imagem, {
      as: 'frame',
      foreignKey: {
        name: 'frameId',
      },
      constraints: false,
    });

    db.pessoas_frame.belongsTo(db.clientes, {
      as: 'clientes',
      foreignKey: {
        name: 'clientesId',
      },
      constraints: false,
    });

    db.pessoas_frame.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.pessoas_frame.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return pessoas_frame;
};
